<?php
if(!defined('ROOT')) die();
define('RETURNCODE', ((isset($_SESSION['blogReturnCode'])) ? $_SESSION['blogReturnCode'] : ''));
$data['blogMode'] = '';
$data['blogConfig'] = 'close';

switch(RETURNCODE) {
	case 'config0':
		$data['blogMsg'] = 'La configuration est enregistrée.';
		$data['blogMsgType'] = 'success';
		$data['blogConfig'] = 'open';
		$_SESSION['blogReturnCode'] = '';
		break;
	case 'config1':
		$data['blogMsg'] = 'Le nom du blog doit être renseigné.';
		$data['blogMsgType'] = 'error';
		$data['blogConfig'] = 'open';
		$_SESSION['blogReturnCode'] = '';
		break;
	case 'config2':
		$data['blogMsg'] = 'Problème lors de l\'enregistrement de la configuration.';
		$data['blogMsgType'] = 'error';
		$data['blogConfig'] = 'open';
		$_SESSION['blogReturnCode'] = '';
		break;
	case 'entry0':
		$data['blogMsg'] = 'Le billet est enregistré.';
		$data['blogMsgType'] = 'success';
		$_SESSION['blogReturnCode'] = '';
		break;
	case 'entry1':
		$data['blogMsg'] = 'Tous les champs doivent être renseignés.';
		$data['blogMsgType'] = 'error';
		$_SESSION['blogReturnCode'] = '';
		break;
	case 'comment0':
		$data['blogMsg'] = 'Le commentaire est enregistré.';
		$data['blogMsgType'] = 'success';
		$_SESSION['blogReturnCode'] = '';
		break;
	case 'category0':
		$data['blogMsg'] = 'La catégorie a bien été ajoutée.';
		$data['blogMsgType'] = 'success';
		$_SESSION['blogReturnCode'] = '';
		break;
	case 'category1':
		$data['blogMsg'] = 'Le nom de catégorie est obligatoire.';
		$data['blogMsgType'] = 'error';
		$_SESSION['blogReturnCode'] = '';
		break;
	default:
		$data['blogMsg'] = '';
		$data['blogMsgType'] = '';
}
if (isset($_GET['m'])) {
	$message = $_GET['m'];
} else {
	$message = '';
}

$blog = new blog(true, true);

switch (ACTION) {
	case 'save':
		if ($_POST['save_type'] == 'config') {
			if (empty($_POST['blog_title'])) {
				$_SESSION['blogReturnCode'] = 'config1';
				header('location:index.php?p=blog');
				die();
			} else {			
				$runPlugin->setConfigVal('title', $_POST['blog_title']);
				$runPlugin->setConfigVal('author', $_POST['blog_author']);
				$runPlugin->setConfigVal('entry_per_page', $_POST['blog_entry_per_page']);
				$runPlugin->setConfigVal('with_comment', $_POST['blog_with_comment']=='on');
				$runPlugin->setConfigVal('captcha', $_POST['blog_captcha']=='on');
				if (plugin::saveConfig($runPlugin)) {
					$_SESSION['blogReturnCode'] = 'config0';
				} else {
					$_SESSION['blogReturnCode'] = 'config2';
				}
				header('location:index.php?p=blog');
				die();
			}
		} else if ($_POST['save_type'] == 'blog_entry') {
			if (empty($_POST['b_title']) || empty($_POST['b_date']) ||
					empty($_POST['b_author']) || empty($_POST['b_content'])) {
				$_SESSION['blogReturnCode'] = 'entry1';
				$_SESSION['entryData'] = array(
					'id' => $_POST['b_id'],
					'title' => $_POST['b_title'],
					'published' => $_POST['b_published'],
					'date' => $_POST['b_date'],
					'author' => $_POST['b_author'],
					'content' => $_POST['b_content'],
				);
				header('location:index.php?p=blog&action=edit');
				die();
			} else {	
				if ($_POST['b_id'] != '') {
					$blogEntry = $blog->getEntry($_POST['b_id']);
				} else {
					$blogEntry = new blogEntry();
				}
				$blogEntry->setTitle($_POST['b_title']);
				$blogEntry->setPublished($_POST['b_published']);
				$blogEntry->setDate($_POST['b_date']);
				$blogEntry->setAuthor($_POST['b_author']);
				$blogEntry->setCategory($_POST['b_category']);
				$blogEntry->setContent($_POST['b_content']);
				$blog->addEntry($blogEntry);
				
				if ($_POST['b_category'] != -1) {
					blog::updateCategoryIndex($_POST['b_category']);
				}
				
				$_SESSION['blogReturnCode'] = 'entry0';
				header('location:index.php?p=blog&action=edit&id='.$blogEntry->getId());
				die();
			}
		} else if ($_POST['save_type'] == 'comment_entry') {
			$comment = $blog->getComment($_POST['b_id'], $_POST['c_id']);
			$comment->setPublished(isset($_POST['c_published']));
			$comment->setContent($_POST['c_content']);
			$blog->addComment($_POST['b_id'], $comment);

			$_SESSION['blogReturnCode'] = 'comment0';
			header('location:index.php?p=blog&action=edit&id='.$_POST['b_id'].'&cid='.$_POST['c_id']);
			die();
		} else if ($_POST['save_type'] == 'category') {
			if (empty($_POST['label'])) {
				$_SESSION['blogReturnCode'] = 'category1';
				header('location:index.php?p=blog&action=categories');
				die();
			} else {
				$category = new category();
				$category->setLabel($_POST['label']);
				blog::addCategory($category);
				$_SESSION['blogReturnCode'] = 'category0';
				header('location:index.php?p=blog&action=categories');
				die();
			}
		} else {
			header('location:index.php?p=blog');
			die();
		}
		break;
	case 'edit':
		if (isset($_GET['cid'])) {
			$data['blogMode'] = 'editcomment';
			
			$comment = $blog->getComment($_GET['id'], $_GET['cid']);
			$data['commentEntry'] = $comment->toArray();
		} else {
			$data['blogMode'] = 'edit';
		
			if (RETURNCODE == 'entry1') {
				$data['blogEntry'] = $_SESSION['entryData'];
				unset($_SESSION['entryData']);
			} else {
				$blogEntry = (isset($_GET['id'])) ? $blog->getEntry($_GET['id']) : new blogEntry();
				$data['blogEntry'] = $blogEntry->toArray();
			}
		
			if (!$data['blogEntry']['date']) {
				$data['blogEntry']['date'] = time();
			}
			if (!$data['blogEntry']['author']) {
				$data['blogEntry']['author'] = $runPlugin->getConfigVal('author');
			}
			
			$categories = array();
			foreach (blog::listCategories() as $category) {
				$categories[] = $category->toArray();
			}
		}
		break;
	case 'comments':
		if (!isset($_GET['id'])) {
			header('location:index.php?p=blog');
			die();
		}
		$data['blogMode'] = 'comments';
		$blog->populateComments($_GET['id'], true, true);
		$blogEntry = $blog->getEntry($_GET['id']);
		$data['blogEntry'] = $blogEntry->toArray();
		break;
	case 'categories':
		$data['blogMode'] = 'categories';
		$categories = array();
		foreach (blog::listCategories() as $category) {
			$categories[] = $category->toArray();
		}
		break;
	case 'del':
		echo 'Deleting';
		if (isset($_GET['cid'])) {
			$blog->delComment($_GET['id'], $_GET['cid']);
			header('location:index.php?p=blog&action=comments&id='.$_GET['id']);
			die();
		} else if (isset($_GET['catid'])) {
			blog::deleteCategory($_GET['catid']);
			header('location:index.php?p=blog&action=categories');
			die();
		} else {
			$entry = $blog->getEntry($_GET['id']);
			$catid = $entry->getCategory();
			$blog->delEntry($_GET['id']);
			if ($catid != -1) {
				blog::updateCategoryIndex($catid);
			}
			header('location:index.php?p=blog');
			die();
		}
		break;
	default:
		$data['blogMode'] = 'list';
		$data['blogList'] = array();
		foreach($blog->getEntries() as $k=>$blogEntry){
			$data['blogList'][$k] = $blogEntry->toArray();
		}
}

$data['linkTags'][] = ROOT.'plugin/blog/admin.css';
?>

<?php 
	include_once(ROOT.'admin/header.php');
	showMsg($data['blogMsg'], $data['blogMsgType']);
	
	$captcha = $runPlugin->getConfigVal('captcha');
	
	include_once(ROOT.'plugin/blog/tpl/admin-configuration.php');
	
	if ($data['blogMode'] == 'list') {

		include_once(ROOT.'plugin/blog/tpl/admin-liste-billets.php');

	} elseif ($data['blogMode'] == 'categories') {
	
		include_once(ROOT.'plugin/blog/tpl/admin-liste-categories.php');
		
	} elseif ($data['blogMode'] == 'edit') {
	
		include_once(ROOT.'plugin/blog/tpl/admin-edit-billet.php');
		
	} elseif ($data['blogMode'] == 'comments') {
	
		include_once(ROOT.'plugin/blog/tpl/admin-liste-commentaires.php');
		
	} elseif	($data['blogMode'] == 'editcomment'){
	
		include_once(ROOT.'plugin/blog/tpl/admin-edit-commentaire.php');
		
	}
	include_once(ROOT.'admin/footer.php');
?>
