<?php

###### declaration
define('BLOG_DATAPATH', ROOT.'data/plugin/blog/');
define('BLOG_PLUGINPATH', ROOT.'plugin/blog/');

require_once(BLOG_PLUGINPATH.'lib/blog.class.php');
require_once(BLOG_PLUGINPATH.'lib/blogEntry.class.php');
require_once(BLOG_PLUGINPATH.'lib/commentEntry.class.php');
require_once(BLOG_PLUGINPATH.'lib/category.class.php');

###### portion obligatoire
if(!defined('ROOT')) die();
function blogConfig(){
	return array(
		'priority' => 2,
		'activate' => 1,
		'title' => 'Blog',
		'author' => '',
		'entry_per_page' => 5,
		'with_comment' => true,
		'captcha' => false
	);
}
function blogInfos(){
	return array(
		'name' => 'Blog',
		'description' => 'Permet de poster des billets ou articles et aux visiteurs de les commenter.',
		'author' => 'Florent Fortat',
		'authorEmail' => 'florent.fortat@maxgun.fr',
		'authorWebsite' => 'http://www.maxgun.fr/',
		'version' => '0.4.1',
	);
}
function blogHooks(){
	return array(
		'startFrontIncludePluginFile' => 'blogHook1',
		'endFrontHead' => 'blogLinkAtom'
	);	
}

###### installation
if (is_dir(BLOG_DATAPATH) && !is_file(BLOG_DATAPATH.'index.json')) {
	!blog::updateIndex();
}

if (!is_dir(BLOG_DATAPATH.'atom') && !is_file(BLOG_DATAPATH.'atom/blog.atom')) {
	include(BLOG_PLUGINPATH.'atom.php');
}

if (!is_dir(BLOG_DATAPATH.'categories')) {
	mkdir(BLOG_DATAPATH.'categories');
}

if (!is_file(BLOG_DATAPATH.'categories.json')) {
	file_put_contents(BLOG_DATAPATH.'categories.json', '');
}

###### hooks
function blogHook1(){
	$temp = '';
	$temp.= "\$temp['target'] = 'index.php?p=blog';";
	$temp.= "\$temp['label'] = '".getConfVal('blog','title')."';";
	$temp.= "array_push(\$data['mainNavigation'], \$temp);";
	return $temp;
}

function blogLinkAtom() {
	$temp = "echo \"\\n\\t\".'<link rel=\"alternate\" type=\"application/atom+xml\" title=\"'.\$data['siteName'].'\" href=\"'.\$data['siteUrl'].'/data/plugin/blog/atom/blog.atom\" />'.\"\\n\";";
	return $temp;
}

###### library

function blogUseCaptcha() {
	return getConfVal('blog', 'captcha') && blogCaptchaIsActive();
}

function blogCaptchaIsActive() {
	return plugin::isActive('captcha');
}

function blogStrToTime($str) {
	$timestamp = 0;

// format composé du plugin blog : 23.12.2011 - 15:44
	$year = substr($str, 6, 4);
	$month = substr($str, 3, 2);
	$day = substr($str, 0, 2);
	$hour = substr($str, 13, 2);
	$minute = substr($str, 16, 2);
	$seconds = '00';
	
// format composé MySQL utilisé : 2008-08-17 18:11:31
	$composed = $year.'-'.$month.'-'.$day.' '.$hour.':'.$minute.':'.$seconds;
	
	$timestamp = strtotime($composed);
	
	return $timestamp;
}

function blogTimeToStr($timestamp) {
	$str = '';
	
	if (is_numeric($timestamp)) {
// format composé du plugin blog : 23.12.2011 - 15:44
		$str = date('d.m.Y - H:i', $timestamp);
	}
	
	return $str;
}

?>
